diff --git a/game/core/src/main/resources/lang/en_US/tile.lang b/game/core/src/main/resources/lang/en_US/tile.lang
index ea25c034b..05fcf0d53 100644
--- a/game/core/src/main/resources/lang/en_US/tile.lang
+++ b/game/core/src/main/resources/lang/en_US/tile.lang
@@ -668,7 +668,7 @@ tile.wire.redstone.name=Redstone Wire
 tile.wire.redstone.desc=A strand of redstone dust laid on the ground.
 
 tile.torch.redstone.idle.name=Redstone Torch
-tile.torch.redstone.idle.desc=Emits a constant redstone signal.
+tile.torch.redstone.idle.desc=Exudes negative energy.
 tile.torch.redstone.active.name=Redstone Torch
 tile.torch.redstone.active.desc=Emits a constant redstone signal.
 
@@ -678,7 +678,7 @@ tile.button.planks.name=Wooden Button
 tile.button.planks.desc=Emits a brief redstone signal when pressed.
 
 tile.button.planks.painted.name=Mystery Button
-tile.button.planks.painted.desc=Emits a brief redstone signal when pressed.
+tile.button.planks.painted.desc=How did you get this?!
 tile.button.planks.painted.black.name=Black Wooden Button
 tile.button.planks.painted.black.desc=Emits a brief redstone signal when pressed.
 tile.button.planks.painted.red.name=Red Wooden Button
@@ -1420,4 +1420,4 @@ tile.statue.pigman.upper.desc=
 tile.comparer.name=Comparer
 tile.comparer.desc=Compares the block infront to the block behind.
 tile.comparer.active.name=Comparer
-tile.comparer.desc=Compares the block infront to the block behind.
\ No newline at end of file
+tile.comparer.desc=Compares the block infront to the block behind.
diff --git a/game/server/src/main/java/net/minecraft/server/MinecraftServer.java b/game/server/src/main/java/net/minecraft/server/MinecraftServer.java
index 1763b5436..afaffe79b 100644
--- a/game/server/src/main/java/net/minecraft/server/MinecraftServer.java
+++ b/game/server/src/main/java/net/minecraft/server/MinecraftServer.java
@@ -15,6 +15,7 @@ import net.minecraft.core.data.DataLoader;
 import net.minecraft.core.data.legacy.LegacyWorldTypes;
 import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.entity.EntityDispatcher;
+import net.minecraft.core.entity.EntityItem;
 import net.minecraft.core.entity.SkinVariantList;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.lang.I18n;
@@ -253,6 +254,7 @@ public class MinecraftServer
         autoSaveInterval = propertyManager.getIntProperty("autosaveInterval", 5);
         chunksSavedPerAutosave = propertyManager.getIntProperty("maxChunksSavedPerAutosave", 24);
         forceSaveAllChunksOnAutosave = propertyManager.getBooleanProperty("forceSaveAllChunksOnAutosave", false);
+        EntityItem.enableItemClumping = propertyManager.getBooleanProperty("enable-item-clumping", true);
 
         String gamemodeProperty = propertyManager.getStringProperty("default-gamemode", "survival");
         defaultGamemode = null;
diff --git a/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerServer.java b/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerServer.java
index 163871243..7f5267794 100644
--- a/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerServer.java
+++ b/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerServer.java
@@ -242,7 +242,7 @@ public class PacketHandlerServer extends PacketHandler
         playerEntity.move(dx, dy, dz);
         // Get the difference in intended move and actual move
         dx = newPosX - playerEntity.x;
-        double ndy = newPosY - playerEntity.y;
+        double ndy = Math.max(newPosY - playerEntity.y, -0.0784);
         dz = newPosZ - playerEntity.z;
         velSquared = dx * dx + ndy * ndy + dz * dz;
         boolean movedWrong = false;
@@ -387,14 +387,14 @@ public class PacketHandlerServer extends PacketHandler
     }
 
     @Override
-    public void handlePlace(PacketUseItem packet)
+    public void handlePlace(PacketUseOrPlaceItemStack packet)
     {
         if (!canInteract()) return;
         WorldServer worldserver = mcServer.getDimensionWorld(playerEntity.dimension);
         ItemStack itemstack = playerEntity.inventory.getCurrentItem();
         boolean ignoreSpawnProtection = mcServer.spawnProtectionRange <= 0 || worldserver.dimension.id != 0 || mcServer.playerList.isOp(playerEntity.uuid);
         switch (packet.type) {
-            case PacketUseItem.TYPE_USE_ITEM_ON: {
+            case PacketUseOrPlaceItemStack.TYPE_USE_OR_PLACE_ON_TILE: {
                 int x = packet.xPosition;
                 int y = packet.yPosition;
                 int z = packet.zPosition;
@@ -410,22 +410,24 @@ public class PacketHandlerServer extends PacketHandler
                 }
                 if (hasMoved && playerEntity.distanceToSqr((double) x + 0.5D, (double) y + 0.5D, (double) z + 0.5D) < 64D && (j1 > mcServer.spawnProtectionRange || ignoreSpawnProtection))
                 {
-                    playerEntity.playerController.useItemOn(playerEntity, worldserver, itemstack, x, y, z, direction.getSide(), xPlaced, yPlaced);
+                    playerEntity.playerController.useOrPlaceItemStackOnTile(playerEntity, worldserver, itemstack, x, y, z, direction.getSide(), xPlaced, yPlaced);
                 }
                 playerEntity.playerNetServerHandler.sendPacket(new PacketBlockUpdate(x, y, z, worldserver));
                 x += direction.getOffsetX();
                 y += direction.getOffsetY();
                 z += direction.getOffsetZ();
                 playerEntity.playerNetServerHandler.sendPacket(new PacketBlockUpdate(x, y, z, worldserver));
+                break;
             }
-            case PacketUseItem.TYPE_USE_ITEM: {
+            case PacketUseOrPlaceItemStack.TYPE_USE_ON_NOTHING: {
                 if (itemstack == null)
                 {
                     return;
                 }
-                playerEntity.playerController.useItemOnNothing(playerEntity, worldserver, itemstack);
+                playerEntity.playerController.useItemStackOnNothing(playerEntity, worldserver, itemstack);
+                break;
             }
-            case PacketUseItem.TYPE_USE_STACK_ON: {
+            case PacketUseOrPlaceItemStack.TYPE_PLACE_ONLY: {
                 int x = packet.xPosition;
                 int y = packet.yPosition;
                 int z = packet.zPosition;
@@ -441,13 +443,14 @@ public class PacketHandlerServer extends PacketHandler
                 }
                 if (hasMoved && playerEntity.distanceToSqr((double) x + 0.5D, (double) y + 0.5D, (double) z + 0.5D) < 64D && (j1 > mcServer.spawnProtectionRange || ignoreSpawnProtection))
                 {
-                    playerEntity.playerController.onlyUseItemStackOn(playerEntity, worldserver, itemstack, x, y, z, direction.getSide(), xPlaced, yPlaced);
+                    playerEntity.playerController.placeItemStackOnTile(playerEntity, worldserver, itemstack, x, y, z, direction.getSide(), xPlaced, yPlaced);
                 }
                 playerEntity.playerNetServerHandler.sendPacket(new PacketBlockUpdate(x, y, z, worldserver));
                 x += direction.getOffsetX();
                 y += direction.getOffsetY();
                 z += direction.getOffsetZ();
                 playerEntity.playerNetServerHandler.sendPacket(new PacketBlockUpdate(x, y, z, worldserver));
+                break;
             }
         }
         itemstack = playerEntity.inventory.getCurrentItem();
diff --git a/game/server/src/main/java/net/minecraft/server/world/ServerPlayerController.java b/game/server/src/main/java/net/minecraft/server/world/ServerPlayerController.java
index 57692bb5f..bd853354b 100644
--- a/game/server/src/main/java/net/minecraft/server/world/ServerPlayerController.java
+++ b/game/server/src/main/java/net/minecraft/server/world/ServerPlayerController.java
@@ -144,26 +144,24 @@ public class ServerPlayerController
         return flag;
     }
 
-    public boolean useItemOnNothing(Player entityplayer, World world, ItemStack itemstack)
-    {
-        if (!entityplayer.getGamemode().canInteract()) return false;
-        int i = itemstack.stackSize;
-        ItemStack itemstack1 = itemstack.useItemRightClick(world, entityplayer);
-        if(itemstack1 != itemstack || itemstack1 != null && itemstack1.stackSize != i)
-        {
-            entityplayer.inventory.mainInventory[entityplayer.inventory.getCurrentItemIndex()] = itemstack1;
-            if(itemstack1.stackSize <= 0)
-            {
-                entityplayer.inventory.mainInventory[entityplayer.inventory.getCurrentItemIndex()] = null;
-            }
-            return true;
-        } else
-        {
-            return false;
-        }
+    /**
+     * Deprecated in 7.3_03
+     * <p>
+     * Calls through to {@link ServerPlayerController#useOrPlaceItemStackOnTile(Player, World, ItemStack, int, int, int, Side, double, double)}
+     * <p>
+     * Can be removed at any time.
+     */
+    @Deprecated
+    public boolean useItemOn(Player entityplayer, World world, ItemStack itemstack, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced){
+        return useOrPlaceItemStackOnTile(entityplayer, world, itemstack, blockX, blockY, blockZ, side, xPlaced, yPlaced);
     }
 
-    public boolean useItemOn(Player entityplayer, World world, ItemStack itemstack, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
+    /**
+     * Used to dynamically use or place an ItemStack on any given tile.
+     * <p>
+     * (i.e. interacting with a chest while holding a block, defaulting to opening the chest when standing, vs. placing the block when crouched)
+     */
+    public boolean useOrPlaceItemStackOnTile(Player entityplayer, World world, ItemStack itemstack, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
     {
         if (!entityplayer.getGamemode().canInteract()) return false;
         int blockId = world.getBlockId(blockX, blockY, blockZ);
@@ -199,7 +197,60 @@ public class ServerPlayerController
         }
     }
 
+    /**
+     * Deprecated in 7.3_03
+     * <p>
+     * Calls through to {@link ServerPlayerController#useItemStackOnNothing(Player, World, ItemStack)}
+     * <p>
+     * Can be removed at any time.
+     */
+    @Deprecated
+    public boolean useItemOnNothing(Player entityplayer, World world, ItemStack itemstack) {
+        return useItemStackOnNothing(entityplayer, world, itemstack);
+    }
+
+    /**
+     * Used to specifically use an ItemStack on nothing, most commonly defaulting to typical "item use" behavior.
+     * <p>
+     * (i.e. throwing a fishing rod or shooting a bow)
+     */
+    public boolean useItemStackOnNothing(Player entityplayer, World world, ItemStack itemstack)
+    {
+        if (!entityplayer.getGamemode().canInteract()) return false;
+        int i = itemstack.stackSize;
+        ItemStack itemstack1 = itemstack.useItemRightClick(world, entityplayer);
+        if(itemstack1 != itemstack || itemstack1 != null && itemstack1.stackSize != i)
+        {
+            entityplayer.inventory.mainInventory[entityplayer.inventory.getCurrentItemIndex()] = itemstack1;
+            if(itemstack1.stackSize <= 0)
+            {
+                entityplayer.inventory.mainInventory[entityplayer.inventory.getCurrentItemIndex()] = null;
+            }
+            return true;
+        } else
+        {
+            return false;
+        }
+    }
+
+    /**
+     * Deprecated in 7.3_03
+     * <p>
+     * Calls through to {@link ServerPlayerController#placeItemStackOnTile(Player, World, ItemStack, int, int, int, Side, double, double)}
+     * <p>
+     * Can be removed at any time.
+     */
+    @Deprecated
     public boolean onlyUseItemStackOn(@NotNull Player player, @NotNull World world, @Nullable ItemStack itemstack, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
+        return placeItemStackOnTile(player, world, itemstack, blockX, blockY, blockZ, side, xPlaced, yPlaced);
+    }
+
+    /**
+     * Used to exclusively place an ItemStack. No interactions, just placing a held ItemStack.
+     * <p>
+     * (i.e. placing blocks using easy bridge)
+     */
+    public boolean placeItemStackOnTile(@NotNull Player player, @NotNull World world, @Nullable ItemStack itemstack, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
         if (!player.getGamemode().canInteract()) return false;
         if (player.getHeldObject() == null) {
             if (itemstack == null) { // No stack then do nothing
diff --git a/gradle/libs.versions.toml b/gradle/libs.versions.toml
index cdbd9729e..a6dc3f026 100644
--- a/gradle/libs.versions.toml
+++ b/gradle/libs.versions.toml
@@ -1,6 +1,6 @@
 [versions]
 log4j = "2.19.0"
-lwjgl = "3.3.4"
+lwjgl = "3.3.3"
 
 [libraries]
 jetbrains-annotations = { module = "org.jetbrains:annotations", version = "24.0.0" }
diff --git a/util/datagen/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java b/util/datagen/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java
index 69bc0014e..c284e03aa 100644
--- a/util/datagen/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java
+++ b/util/datagen/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java
@@ -1,16 +1,17 @@
 package net.minecraft.datagen;
 
 import net.minecraft.core.block.Block;
+import net.minecraft.core.data.registry.recipe.entry.RecipeEntryCraftingWithTool;
+import net.minecraft.core.data.registry.recipe.entry.RecipeEntryDyeing;
+import net.minecraft.core.data.registry.recipe.entry.RecipeEntryRepairable;
+import net.minecraft.core.data.registry.recipe.entry.RecipeEntryScrap;
+import net.minecraft.core.data.registry.recipe.entry.RecipeEntryUndyeing;
 import net.minecraft.core.item.Item;
 import net.minecraft.datagen.recipeBuilders.RecipeBuilder;
 import net.minecraft.datagen.recipeBuilders.RecipeBuilderShaped;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.data.registry.recipe.RecipeSymbol;
-import net.minecraft.core.data.registry.recipe.entry.RecipeEntryCraftingWithTool;
-import net.minecraft.core.data.registry.recipe.entry.RecipeEntryRepairable;
-import net.minecraft.core.data.registry.recipe.entry.RecipeEntryScrap;
-import net.minecraft.core.data.registry.recipe.entry.RecipeEntryUndyeing;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.util.helper.DyeColor;
@@ -48,8 +49,6 @@ class WorkbenchGenerator {
 
         generateLogToPlanks();
         generateDyes();
-        generateDyedWools();
-        generateDyedPlanks();
 
         generateInformationals();
         generateRedstoneComponents();
@@ -61,6 +60,7 @@ class WorkbenchGenerator {
         generateToolRecipes();
 
         generateUndyeingRecipes();
+        generateDyeingRecipes();
 
         generateStatueRecipes();
 
@@ -110,7 +110,7 @@ class WorkbenchGenerator {
                 "###")
             .addInput('#', "minecraft:planks")
             .addInput('X', Items.BOOK)
-            .create("bookshelf", Blocks.BOOKSHELF_PLANKS_OAK.getDefaultStack());
+            .create("bookshelf", new ItemStack(Blocks.BOOKSHELF_PLANKS_OAK, 4));
 
         RecipeBuilder.Shaped(CORE_NAMESPACE)
             .setShape(
@@ -425,13 +425,10 @@ class WorkbenchGenerator {
             .addInput('#', Blocks.MARBLE)
             .create("marble_pillar", new ItemStack(Blocks.PILLAR_MARBLE, 2));
 
-        RecipeBuilder.Shaped(CORE_NAMESPACE)
-            .setShape(
-                "PI",
-                "S ")
-            .addInput('P', Items.PAPER)
-            .addInput('I', new ItemStack(Items.DYE, 1, DyeColor.BLACK.itemMeta))
-            .addInput('S', Items.STRING)
+        RecipeBuilder.Shapeless(CORE_NAMESPACE)
+            .addInput(Items.PAPER)
+            .addInput(new ItemStack(Items.DYE, 1, DyeColor.BLACK.itemMeta))
+            .addInput(Items.STRING)
             .create("blank_label", Items.LABEL.getDefaultStack());
     }
     private static void generatePickaxes() {
@@ -871,15 +868,15 @@ class WorkbenchGenerator {
 
     private static void generateSigns() {
         RecipeBuilderShaped sign = RecipeBuilder.Shaped(CORE_NAMESPACE)
-            .setShape(
-                "XXX",
-                "XXX",
-                " # ")
-            .addInput('#', Items.STICK);
+                .setShape(
+                        "XXX",
+                        "XXX",
+                        " # ")
+                .addInput('#', Items.STICK);
         final int stackSize = 4;
 
         sign.addInput('X', Blocks.PLANKS_OAK)
-            .create("sign", new ItemStack(Items.SIGN, stackSize));
+                .create("sign", new ItemStack(Items.SIGN, stackSize));
         for (final DyeColor color : DyeColor.values()) {
             sign.addInput('X', Blocks.PLANKS_OAK_PAINTED, color.blockMeta).create(color.colorID + "_sign", new ItemStack(Items.SIGN_PAINTED, stackSize, color.itemMeta));
         }
@@ -948,8 +945,6 @@ class WorkbenchGenerator {
 
         for (DyeColor color : DyeColor.values()) {
             chest.addInput('X', Blocks.PLANKS_OAK_PAINTED, color.blockMeta).create(color.colorID + "_wooden_chest_from_planks", new ItemStack(Blocks.CHEST_PLANKS_OAK_PAINTED, 1, color.blockMeta << 4));
-
-            RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput("minecraft:chests").addInput(Items.DYE, color.itemMeta).create(color.colorID + "_wooden_chest_from_chest", new ItemStack(Blocks.CHEST_PLANKS_OAK_PAINTED, 1, color.blockMeta << 4));
         }
         chest.addInput('X', Blocks.PLANKS_OAK).create("wooden_chest", Blocks.CHEST_PLANKS_OAK.getDefaultStack());
     }
@@ -967,24 +962,6 @@ class WorkbenchGenerator {
         RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Blocks.LOG_PINE).create(String.format(format, "pine", "brown"), new ItemStack(Blocks.PLANKS_OAK_PAINTED, stackSize, DyeColor.BROWN.blockMeta));
     }
 
-    private static void generateDyedWools() {
-        for (DyeColor color : DyeColor.values()) {
-            RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput("minecraft:wools").addInput(Items.DYE, color.itemMeta).create(color.colorID + "_wool", new ItemStack(Blocks.WOOL, 1, color.blockMeta));
-        }
-    }
-
-    private static void generateDyedPlanks() {
-        RecipeBuilderShaped planks = RecipeBuilder.Shaped(CORE_NAMESPACE)
-            .setShape(
-                "XXX",
-                "XDX",
-                "XXX"
-            ).addInput('X', "minecraft:planks");
-        for (DyeColor color : DyeColor.values()) {
-            planks.addInput('D', Items.DYE, color.itemMeta).create(color.colorID + "_wooden_planks", new ItemStack(Blocks.PLANKS_OAK_PAINTED, 8, color.blockMeta));
-        }
-    }
-
     private static void generatePolishedStones() {
         RecipeBuilderShaped shape = RecipeBuilder.Shaped(CORE_NAMESPACE)
             .setShape(
@@ -1247,13 +1224,6 @@ class WorkbenchGenerator {
             .addInput('X', Items.DUST_REDSTONE)
             .create("lamp", new ItemStack(Blocks.LAMP_IDLE, 4));
 
-        for (DyeColor color : DyeColor.values()) {
-            RecipeBuilder.Shapeless(CORE_NAMESPACE)
-                .addInput("minecraft:lamps")
-                .addInput(new ItemStack(Items.DYE, 1, color.itemMeta))
-                .create(color.colorID + "_lamp_convert", new ItemStack(Blocks.LAMP_IDLE, 1, color.blockMeta));
-        }
-
         RecipeBuilder.Shaped(CORE_NAMESPACE)
             .setShape(
                 "X",
@@ -1303,7 +1273,7 @@ class WorkbenchGenerator {
                 "X X",
                 "X#X",
                 "XRX")
-            .addInput('#', Blocks.PRESSURE_PLATE_STONE)
+            .addInput('#', "minecraft:pressureplates")
             .addInput('X', Items.INGOT_IRON)
             .addInput('R', Items.DUST_REDSTONE)
             .create("detector_rail", new ItemStack(Blocks.RAIL_DETECTOR, 8));
@@ -1348,6 +1318,25 @@ class WorkbenchGenerator {
         Registries.RECIPES.WORKBENCH.register("carve_pumpkin_sword",     new RecipeEntryCraftingWithTool(new RecipeSymbol(Blocks.PUMPKIN.getDefaultStack()), new RecipeSymbol("minecraft:tool_swords"),     new ItemStack(Blocks.PUMPKIN_CARVED_IDLE)));
     }
 
+    private static void generateStatueRecipes() {
+        final String[] statueNames = new String[]{"stone", "basalt", "limestone", "granite", "marble"};
+        final Item[] statueItems = new Item[]{Items.STATUE_STONE, Items.STATUE_BASALT, Items.STATUE_LIMESTONE, Items.STATUE_GRANITE, Items.STATUE_MARBLE};
+        final Block<?>[] statueBodyBlocks = new Block[]{Blocks.STONE, Blocks.BASALT, Blocks.LIMESTONE, Blocks.GRANITE, Blocks.MARBLE};
+        final Block<?>[] statueBaseBlocks = new Block[]{Blocks.SLAB_STONE_POLISHED, Blocks.SLAB_BASALT_POLISHED, Blocks.SLAB_LIMESTONE_POLISHED, Blocks.SLAB_GRANITE_POLISHED, Blocks.SLAB_CAPSTONE_MARBLE};
+
+        for (int i = 0; i < statueItems.length; i++) {
+            RecipeBuilder.Shaped(CORE_NAMESPACE)
+                .setShape(
+                    "#",
+                    "#",
+                    "_"
+                )
+                .addInput('#', statueBodyBlocks[i])
+                .addInput('_', statueBaseBlocks[i])
+                .create("statue_" + statueNames[i], new ItemStack(statueItems[i], 1));
+        }
+    }
+
     private static void generateUndyeingRecipes() {
         final String format = "%s_undyeing";
 
@@ -1362,26 +1351,25 @@ class WorkbenchGenerator {
         Registries.RECIPES.WORKBENCH.register(String.format(format, "lamps"), new RecipeEntryUndyeing(new RecipeSymbol("minecraft:lamps"), new ItemStack(Blocks.LAMP_IDLE)));
         Registries.RECIPES.WORKBENCH.register(String.format(format, "wools"), new RecipeEntryUndyeing(new RecipeSymbol("minecraft:wools"), new ItemStack(Blocks.WOOL)));
         Registries.RECIPES.WORKBENCH.register(String.format(format, "chests"), new RecipeEntryUndyeing(new RecipeSymbol("minecraft:chests"), new ItemStack(Blocks.CHEST_PLANKS_OAK)));
-        Registries.RECIPES.WORKBENCH.register(String.format(format, "button_planks"), new RecipeEntryUndyeing(new RecipeSymbol("minecraft:button_planks"), new ItemStack(Blocks.BUTTON_PLANKS)));
+        Registries.RECIPES.WORKBENCH.register(String.format(format, "buttons_planks"), new RecipeEntryUndyeing(new RecipeSymbol("minecraft:button_planks"), new ItemStack(Blocks.BUTTON_PLANKS)));
         Registries.RECIPES.WORKBENCH.register(String.format(format, "pressureplates_planks"), new RecipeEntryUndyeing(new RecipeSymbol("minecraft:pressureplates_planks"), new ItemStack(Blocks.PRESSURE_PLATE_PLANKS_OAK)));
     }
 
-    private static void generateStatueRecipes() {
-        final String[] statueNames = new String[] { "stone", "basalt", "limestone", "granite", "marble" };
-        final Item[] statueItems = new Item[ ] { Items.STATUE_STONE, Items.STATUE_BASALT, Items.STATUE_LIMESTONE, Items.STATUE_GRANITE, Items.STATUE_MARBLE };
-        final Block<?>[] statueBodyBlocks = new Block[] { Blocks.STONE, Blocks.BASALT, Blocks.LIMESTONE, Blocks.GRANITE, Blocks.MARBLE };
-        final Block<?>[] statueBaseBlocks = new Block[] { Blocks.SLAB_STONE_POLISHED, Blocks.SLAB_BASALT_POLISHED, Blocks.SLAB_LIMESTONE_POLISHED, Blocks.SLAB_GRANITE_POLISHED, Blocks.SLAB_CAPSTONE_MARBLE };
-
-        for (int i = 0; i < statueItems.length; i++) {
-            RecipeBuilder.Shaped(CORE_NAMESPACE)
-                .setShape(
-                    "#",
-                    "#",
-                    "_"
-                )
-                .addInput('#', statueBodyBlocks[i])
-                .addInput('_', statueBaseBlocks[i])
-                .create("statue_" + statueNames[i], new ItemStack(statueItems[i], 1));
-        }
+    private static void generateDyeingRecipes() {
+        final String format = "%s_dyeing";
+
+        Registries.RECIPES.WORKBENCH.register(String.format(format, "planks"), new RecipeEntryDyeing(new RecipeSymbol("minecraft:planks"), new ItemStack(Blocks.PLANKS_OAK_PAINTED), false, false));
+        Registries.RECIPES.WORKBENCH.register(String.format(format, "signs"), new RecipeEntryDyeing(new RecipeSymbol("minecraft:signs"), new ItemStack(Items.SIGN_PAINTED), false, true));
+        Registries.RECIPES.WORKBENCH.register(String.format(format, "doors"), new RecipeEntryDyeing(new RecipeSymbol("minecraft:doors"), new ItemStack(Items.DOOR_OAK_PAINTED), false, true));
+        Registries.RECIPES.WORKBENCH.register(String.format(format, "stairs_planks"), new RecipeEntryDyeing(new RecipeSymbol("minecraft:stairs_planks"), new ItemStack(Blocks.STAIRS_PLANKS_PAINTED), true, false));
+        Registries.RECIPES.WORKBENCH.register(String.format(format, "slabs_planks"), new RecipeEntryDyeing(new RecipeSymbol("minecraft:slabs_planks"), new ItemStack(Blocks.SLAB_PLANKS_PAINTED), true, false));
+        Registries.RECIPES.WORKBENCH.register(String.format(format, "fences_planks"), new RecipeEntryDyeing(new RecipeSymbol("minecraft:fences_planks"), new ItemStack(Blocks.FENCE_PLANKS_OAK_PAINTED), false, false));
+        Registries.RECIPES.WORKBENCH.register(String.format(format, "fence_gates_planks"), new RecipeEntryDyeing(new RecipeSymbol("minecraft:fence_gates_planks"), new ItemStack(Blocks.FENCE_GATE_PLANKS_OAK_PAINTED), true, false));
+        Registries.RECIPES.WORKBENCH.register(String.format(format, "trapdoor_planks"), new RecipeEntryDyeing(new RecipeSymbol("minecraft:trapdoor_planks"), new ItemStack(Blocks.TRAPDOOR_PLANKS_PAINTED), true, false));
+        Registries.RECIPES.WORKBENCH.register(String.format(format, "lamps"), new RecipeEntryDyeing(new RecipeSymbol("minecraft:lamps"), new ItemStack(Blocks.LAMP_IDLE), false, false));
+        Registries.RECIPES.WORKBENCH.register(String.format(format, "wools"), new RecipeEntryDyeing(new RecipeSymbol("minecraft:wools"), new ItemStack(Blocks.WOOL), false, false));
+        Registries.RECIPES.WORKBENCH.register(String.format(format, "chests"), new RecipeEntryDyeing(new RecipeSymbol("minecraft:chests"), new ItemStack(Blocks.CHEST_PLANKS_OAK_PAINTED), true, false));
+        Registries.RECIPES.WORKBENCH.register(String.format(format, "buttons_planks"), new RecipeEntryDyeing(new RecipeSymbol("minecraft:button_planks"), new ItemStack(Blocks.BUTTON_PLANKS_PAINTED), true, false));
+        Registries.RECIPES.WORKBENCH.register(String.format(format, "pressureplates_planks"), new RecipeEntryDyeing(new RecipeSymbol("minecraft:pressureplates_planks"), new ItemStack(Blocks.PRESSURE_PLATE_PLANKS_OAK_PAINTED), true, false));
     }
 }
diff --git a/util/datagen/src/main/java/net/minecraft/datagen/recipeBuilders/RecipeBuilder.java b/util/datagen/src/main/java/net/minecraft/datagen/recipeBuilders/RecipeBuilder.java
index c1f6d643c..3fcfa9d36 100644
--- a/util/datagen/src/main/java/net/minecraft/datagen/recipeBuilders/RecipeBuilder.java
+++ b/util/datagen/src/main/java/net/minecraft/datagen/recipeBuilders/RecipeBuilder.java
@@ -74,7 +74,7 @@ public final class RecipeBuilder {
     }
 
     /**
-     * Gets or creates a specified ItemGroup. <br></br>
+     * Gets or creates a specified ItemGroup. <br>
      *
      * Example code:
      * <pre>{@code
@@ -96,7 +96,7 @@ public final class RecipeBuilder {
     }
 
     /**
-     * Adds specified items to an ItemGroup. If the group does not exist before the method is called then it will be created. <br></br>
+     * Adds specified items to an ItemGroup. If the group does not exist before the method is called then it will be created. <br>
      *
      * Example code:
      * <pre>{@code
